/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessengerBusinessProfile type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessengerBusinessProfile{}

// MessengerBusinessProfile 
type MessengerBusinessProfile struct {
	Address *string `json:"address,omitempty"`
	Description *string `json:"description,omitempty"`
	Email *string `json:"email,omitempty"`
	Vertical *string `json:"vertical,omitempty"`
	Websites []string `json:"websites,omitempty"`
}

// NewMessengerBusinessProfile instantiates a new MessengerBusinessProfile object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessengerBusinessProfile() *MessengerBusinessProfile {
	this := MessengerBusinessProfile{}
	return &this
}

// NewMessengerBusinessProfileWithDefaults instantiates a new MessengerBusinessProfile object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessengerBusinessProfileWithDefaults() *MessengerBusinessProfile {
	this := MessengerBusinessProfile{}
	return &this
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *MessengerBusinessProfile) GetAddress() string {
	if o == nil || IsNil(o.Address) {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerBusinessProfile) GetAddressOk() (*string, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *MessengerBusinessProfile) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *MessengerBusinessProfile) SetAddress(v string) {
	o.Address = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *MessengerBusinessProfile) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerBusinessProfile) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *MessengerBusinessProfile) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *MessengerBusinessProfile) SetDescription(v string) {
	o.Description = &v
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *MessengerBusinessProfile) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerBusinessProfile) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *MessengerBusinessProfile) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *MessengerBusinessProfile) SetEmail(v string) {
	o.Email = &v
}

// GetVertical returns the Vertical field value if set, zero value otherwise.
func (o *MessengerBusinessProfile) GetVertical() string {
	if o == nil || IsNil(o.Vertical) {
		var ret string
		return ret
	}
	return *o.Vertical
}

// GetVerticalOk returns a tuple with the Vertical field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerBusinessProfile) GetVerticalOk() (*string, bool) {
	if o == nil || IsNil(o.Vertical) {
		return nil, false
	}
	return o.Vertical, true
}

// HasVertical returns a boolean if a field has been set.
func (o *MessengerBusinessProfile) HasVertical() bool {
	if o != nil && !IsNil(o.Vertical) {
		return true
	}

	return false
}

// SetVertical gets a reference to the given string and assigns it to the Vertical field.
func (o *MessengerBusinessProfile) SetVertical(v string) {
	o.Vertical = &v
}

// GetWebsites returns the Websites field value if set, zero value otherwise.
func (o *MessengerBusinessProfile) GetWebsites() []string {
	if o == nil || IsNil(o.Websites) {
		var ret []string
		return ret
	}
	return o.Websites
}

// GetWebsitesOk returns a tuple with the Websites field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessengerBusinessProfile) GetWebsitesOk() ([]string, bool) {
	if o == nil || IsNil(o.Websites) {
		return nil, false
	}
	return o.Websites, true
}

// HasWebsites returns a boolean if a field has been set.
func (o *MessengerBusinessProfile) HasWebsites() bool {
	if o != nil && !IsNil(o.Websites) {
		return true
	}

	return false
}

// SetWebsites gets a reference to the given []string and assigns it to the Websites field.
func (o *MessengerBusinessProfile) SetWebsites(v []string) {
	o.Websites = v
}

func (o MessengerBusinessProfile) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessengerBusinessProfile) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	if !IsNil(o.Vertical) {
		toSerialize["vertical"] = o.Vertical
	}
	if !IsNil(o.Websites) {
		toSerialize["websites"] = o.Websites
	}
	return toSerialize, nil
}

type NullableMessengerBusinessProfile struct {
	value *MessengerBusinessProfile
	isSet bool
}

func (v NullableMessengerBusinessProfile) Get() *MessengerBusinessProfile {
	return v.value
}

func (v *NullableMessengerBusinessProfile) Set(val *MessengerBusinessProfile) {
	v.value = val
	v.isSet = true
}

func (v NullableMessengerBusinessProfile) IsSet() bool {
	return v.isSet
}

func (v *NullableMessengerBusinessProfile) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessengerBusinessProfile(val *MessengerBusinessProfile) *NullableMessengerBusinessProfile {
	return &NullableMessengerBusinessProfile{value: val, isSet: true}
}

func (v NullableMessengerBusinessProfile) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessengerBusinessProfile) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


